﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class RadGridHierarchyNestedProgrammaticBound : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }
    protected void RadGridOuter_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        RadGridOuter.DataSource = GetGridSource(80);
    }
    protected void RadGridInner_DataBinding(object sender, EventArgs e)
    {
        BindInnerGrid(sender as RadGrid);
    }
    protected void RadGridInner_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        BindInnerGrid(sender as RadGrid);
    }
    private void BindInnerGrid(RadGrid grid)
    {
        GridDataItem parentItem = (grid.NamingContainer as GridNestedViewItem).ParentItem;
        int? value = parentItem.GetDataKeyValue("OrderID") as int?;
        grid.DataSource = GetGridSource(value.Value);
    }
    private DataTable GetGridSource(int customCondition)
    {
        DataTable dataTable = new DataTable();

        DataColumn column = new DataColumn();
        column.DataType = Type.GetType("System.Int32");
        column.ColumnName = "OrderID";
        dataTable.Columns.Add(column);

        column = new DataColumn();
        column.DataType = Type.GetType("System.DateTime");
        column.ColumnName = "OrderDate";
        dataTable.Columns.Add(column);

        column = new DataColumn();
        column.DataType = Type.GetType("System.Decimal");
        column.ColumnName = "Freight";
        dataTable.Columns.Add(column);

        column = new DataColumn();
        column.DataType = Type.GetType("System.String");
        column.ColumnName = "ShipName";
        dataTable.Columns.Add(column);

        column = new DataColumn();
        column.DataType = Type.GetType("System.String");
        column.ColumnName = "ShipCountry";
        dataTable.Columns.Add(column);

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = dataTable.Columns["OrderID"];
        dataTable.PrimaryKey = PrimaryKeyColumns;

        for (int i = 0; i < customCondition; i++)
        {
            DataRow row = dataTable.NewRow();
            row["OrderID"] = i + 1;
            row["OrderDate"] = DateTime.Now;
            row["Freight"] = (i + 1) + (i + 1) * 0.1 + (i + 1) * 0.01;
            row["ShipName"] = "Name " + (i + 1);
            row["ShipCountry"] = "Country " + (i + 1);

            dataTable.Rows.Add(row);
        }

        return dataTable;
    }

}